/* 
 * arch/arm/mach-uniphier/include/mach/nand_partition.h
 *
 * Copyright (C) 2011 Panasonic Corporation
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Generated by   NANDP_GenerationTool.xls
 */

#ifndef	__ASM_ARCH_NAND_PARTITION_H
#define	__ASM_ARCH_NAND_PARTITION_H
#include <linux/config.h>

#if defined(CONFIG_MTD_NAND_MAP_V1)
		static struct mtd_partition nand_gpbc_partition_info[] = {
#if defined(PANA_SAMPLE_BOARD)
			{ .offset = 0x00000000, .size = 0x00040000, .name = "nand_2ndboot", },
			{ .offset = 0x00040000, .size = 0x000C0000, .name = "nand_3rdboot", },
			{ .offset = 0x00100000, .size = 0x000C0000, .name = "nand_uboot", },
			{ .offset = 0x001c0000, .size = 0x00040000, .name = "nand_uboot_env", },
			{ .offset = 0x00200000, .size = 0x00A00000, .name = "nand_ucode", },
			{ .offset = 0x00c00000, .size = 0x00400000, .name = "nand_kernel", },
			{ .offset = 0x01000000, .size = 0x01000000, .name = "nand_rootfs", },
			{ .offset = 0x02000000, .size = 0x08000000, .name = "nand_fs_usr", },
			{ .offset = 0x0a000000, .size = 0x04000000, .name = "nand_fs_home", },
			{ .offset = 0x0e000000, .size = 0x04000000, .name = "nand_fs_nv", },
			{ .offset = 0x12000000, .size = 0x2B500000, .name = "nand_fs_reserved", },
			{ .offset = 0x3d500000, .size = 0x00100000, .name = "nand_fs_channel", },
			{ .offset = 0x3d600000, .size = 0x00100000, .name = "nand_misc", },
			{ .offset = 0x3d700000, .size = 0x00900000, .name = "nand_splashscreen", },
			{ .offset = 0x3e000000, .size = 0x02000000, .name = "nand_sys_bbm1", },
#ifndef CONFIG_MTD_NAND_MN2WS_USE_8GBIT_NAND
			{ .offset = 0x40000000, .size = 0x3E000000, .name = "nand_sys_reserved", },
			{ .offset = 0x7e000000, .size = 0x02000000, .name = "nand_sys_bbm2", },
#endif
#else	/* not PANA_SAMPLE_BOARD */
			/* sharp */
#if 0
			{ .offset = 0x0000000000, .size = 0x00040000, .name = "nand_2ndboot", },
			{ .offset = 0x0000040000, .size = 0x000C0000, .name = "nand_3rdboot", },
			{ .offset = 0x0000100000, .size = 0x000C0000, .name = "nand_uboot", },
			{ .offset = 0x00001c0000, .size = 0x00040000, .name = "nand_uboot_env", },
			{ .offset = 0x0000200000, .size = 0x00A00000, .name = "nand_ucode", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00080000, .name = "param", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00580000, .name = "vkernel", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00300000, .name = "kernel_a", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00300000, .name = "kernel_b", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x03c00000, .name = "rfs_a", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x03c00000, .name = "rfs_b", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00e00000, .name = "system_data", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x01400000, .name = "usr_data", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x01e00000, .name = "ro_data", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x00200000, .name = "tmp", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x01e00000, .name = "manual", },
			{ .offset = MTDPART_OFS_APPEND, .size = 0x01000000, .name = "sys_bbm", },
#else
			{ .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
			{ .offset = 0x00020000, .size = 0x00a00000, .name = "vkernel", },
			{ .offset = 0x00a20000, .size = 0x00020000, .name = "model_info", },
			{ .offset = 0x00a40000, .size = 0x00020000, .name = "swupdate_flag", },
			{ .offset = 0x00a60000, .size = 0x000a0000, .name = "param", },

			{ .offset = 0x00b00000, .size = 0x00080000, .name = "3rdboot_a", },
			{ .offset = 0x00b80000, .size = 0x00080000, .name = "uboot_a", },
			{ .offset = 0x00c00000, .size = 0x00800000, .name = "ucode_a", },
			{ .offset = 0x01400000, .size = 0x00500000, .name = "kernel_a", },
			{ .offset = 0x01900000, .size = 0x06400000, .name = "rfs_a", },
			
			{ .offset = 0x07d00000, .size = 0x00080000, .name = "3rdboot_b", },
			{ .offset = 0x07d80000, .size = 0x00080000, .name = "uboot_b", },
			{ .offset = 0x07e00000, .size = 0x00800000, .name = "ucode_b", },
			{ .offset = 0x08600000, .size = 0x00500000, .name = "kernel_b", },
			{ .offset = 0x08b00000, .size = 0x06400000, .name = "rfs_a", },

			{ .offset = 0x0ef00000, .size = 0x06400000, .name = "3rd", },
			{ .offset = 0x15300000, .size = 0x01e00000, .name = "system_data", },
			{ .offset = 0x17100000, .size = 0x02800000, .name = "usr_data", },
			{ .offset = 0x19900000, .size = 0x01e00000, .name = "ro_data", },
			{ .offset = 0x1b700000, .size = 0x00700000, .name = "tmp", },
			{ .offset = 0x1be00000, .size = 0x03200000, .name = "manual", },
			{ .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", },
#endif
#endif	/* not PANA_SAMPLE_BOARD */

		};
#elif defined(CONFIG_MTD_NAND_MAP_V2)
#if defined(PANA_SAMPLE_BOARD)
                static struct mtd_partition nand_gpbc_partition_info[] = {
                        { .offset = 0x00000000, .size = 0x00040000, .name = "nand_2ndboot", },
                        { .offset = 0x00040000, .size = 0x00080000, .name = "nand_model_info", },
                        { .offset = 0x000C0000, .size = 0x00080000, .name = "nand_swupdate_flag", },
                        { .offset = 0x00140000, .size = 0x00040000, .name = "nand_3rdboot", },
                        { .offset = 0x00180000, .size = 0x00040000, .name = "nand_uboot", },
                        { .offset = 0x001c0000, .size = 0x00800000, .name = "nand_ucode", },
                        { .offset = 0x009c0000, .size = 0x00400000, .name = "nand_kernel", },
                        { .offset = 0x00dc0000, .size = 0x00800000, .name = "nand_rootfs", },
                        { .offset = 0x015c0000, .size = 0x10000000, .name = "nand_fs_usr", },
                        { .offset = 0x115c0000, .size = 0x11480000, .name = "nand_bank1", },
                        { .offset = 0x22a40000, .size = 0x00040000, .name = "nand_uboot_env", },
                        { .offset = 0x22a80000, .size = 0x08000000, .name = "nand_fs_nv", },
                        { .offset = 0x2aa80000, .size = 0x00100000, .name = "nand_fs_nv2", },
                        { .offset = 0x2ab80000, .size = 0x04000000, .name = "nand_fs_custom", },
                        { .offset = 0x2eb80000, .size = 0x00900000, .name = "nand_splashscreen", },
                        { .offset = 0x2f480000, .size = 0x0A680000, .name = "nand_reserved", },
                        { .offset = 0x39b00000, .size = 0x00100000, .name = "nand_misc", },
                        { .offset = 0x39c00000, .size = 0x06400000, .name = "nand_sys_bbm", },
               	};
#if defined(CONFIG_NANDBOOT_BANKCHOICE)
                static struct mtd_partition nand_gpbc_partition_info1[] = {
                        { .offset = 0x00000000, .size = 0x00040000, .name = "nand_2ndboot", },
                        { .offset = 0x00040000, .size = 0x00080000, .name = "nand_model_info", },
                        { .offset = 0x000C0000, .size = 0x00080000, .name = "nand_swupdate_flag", },
                        { .offset = 0x115c0000, .size = 0x00040000, .name = "nand_3rdboot", },
                        { .offset = 0x11600000, .size = 0x00040000, .name = "nand_uboot", },
                        { .offset = 0x11640000, .size = 0x00800000, .name = "nand_ucode", },
                        { .offset = 0x11e40000, .size = 0x00400000, .name = "nand_kernel", },
                        { .offset = 0x12240000, .size = 0x00800000, .name = "nand_rootfs", },
                        { .offset = 0x12a40000, .size = 0x10000000, .name = "nand_fs_usr", },
                        { .offset = 0x00140000, .size = 0x11480000, .name = "nand_bank1", },
                        { .offset = 0x22a40000, .size = 0x00040000, .name = "nand_uboot_env", },
                        { .offset = 0x22a80000, .size = 0x08000000, .name = "nand_fs_nv", },
                        { .offset = 0x2aa80000, .size = 0x00100000, .name = "nand_fs_nv2", },
                        { .offset = 0x2ab80000, .size = 0x04000000, .name = "nand_fs_custom", },
                        { .offset = 0x2eb80000, .size = 0x00900000, .name = "nand_splashscreen", },
                        { .offset = 0x2f480000, .size = 0x0A680000, .name = "nand_reserved", },
                        { .offset = 0x39b00000, .size = 0x00100000, .name = "nand_misc", },
                        { .offset = 0x39c00000, .size = 0x06400000, .name = "nand_sys_bbm", },
		};
#endif	//defined(CONFIG_NANDBOOT_BANKCHOICE)
#else	/* not PANA_SAMPLE_BOARD */
			/* sharp */
			static struct mtd_partition nand_gpbc_partition_info[] = {
				{ .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
				{ .offset = 0x00020000, .size = 0x00040000, .name = "v3rdboot", },
				{ .offset = 0x00060000, .size = 0x00040000, .name = "vuboot", },
				{ .offset = 0x000a0000, .size = 0x00800000, .name = "vucode", },
				{ .offset = 0x008a0000, .size = 0x00a00000, .name = "vkernel", },
				{ .offset = 0x012a0000, .size = 0x00100000, .name = "model_info", },
				{ .offset = 0x013a0000, .size = 0x00080000, .name = "swupdate_flag", },
				{ .offset = 0x01420000, .size = 0x00040000, .name = "uboot_env", },
				{ .offset = 0x01460000, .size = 0x000a0000, .name = "param", },
				
				{ .offset = 0x01500000, .size = 0x00040000, .name = "3rdboot_a", },
				{ .offset = 0x01540000, .size = 0x00040000, .name = "uboot_a", },
				{ .offset = 0x01580000, .size = 0x00800000, .name = "ucode_a", },
				{ .offset = 0x01d80000, .size = 0x00a00000, .name = "kernel_a", },
				{ .offset = 0x02780000, .size = 0x00a00000, .name = "rfs_a", },
				{ .offset = 0x03180000, .size = 0x05000000, .name = "usr_a", },
				
				{ .offset = 0x08180000, .size = 0x00040000, .name = "3rdboot_b", },
				{ .offset = 0x081c0000, .size = 0x00040000, .name = "uboot_b", },
				{ .offset = 0x08200000, .size = 0x00800000, .name = "ucode_b", },
				{ .offset = 0x08a00000, .size = 0x00a00000, .name = "kernel_b", },
				{ .offset = 0x09400000, .size = 0x00a00000, .name = "rfs_b", },
				{ .offset = 0x09e00000, .size = 0x05000000, .name = "usr_b", },
				
				{ .offset = 0x0ee00000, .size = 0x06400000, .name = "3rd", },
				{ .offset = 0x15200000, .size = 0x01e00000, .name = "sys_data", },
				{ .offset = 0x17000000, .size = 0x02800000, .name = "usr_data", },
				{ .offset = 0x19800000, .size = 0x01e00000, .name = "ro_data", },
				{ .offset = 0x1b600000, .size = 0x00700000, .name = "tmp", },
				{ .offset = 0x1bd00000, .size = 0x03300000, .name = "manual", },
				{ .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", }
			};
#endif	/* not PANA_SAMPLE_BOARD */

#else	//defined(CONFIG_MTD_NAND_MAP_V1) elif defined(CONFIG_MTD_NAND_MAP_V2)
# error Unknown NAND MAP version !!
#endif	//defined(CONFIG_MTD_NAND_MAP_V1) elif defined(CONFIG_MTD_NAND_MAP_V2)

#endif
